package ru.dbotthepony.kstarbound.client.render

import org.lwjgl.glfw.GLFW.*
import ru.dbotthepony.kstarbound.math.*

class Camera {
	/**
	 * Позиция этой камеры в Starbound Unit'ах
	 */
	val pos = MutableVector2f()

	var pressedLeft = false
		private set

	var pressedRight = false
		private set

	var pressedUp = false
		private set

	var pressedDown = false
		private set

	fun userInput(key: Int, scancode: Int, action: Int, mods: Int) {
		when (key) {
			GLFW_KEY_LEFT -> pressedLeft = action > 0
			GLFW_KEY_RIGHT -> pressedRight = action > 0
			GLFW_KEY_UP -> pressedUp = action > 0
			GLFW_KEY_DOWN -> pressedDown = action > 0
		}
	}

	val velocity: MutableVector2f get() {
		val vec = MutableVector2f()

		if (pressedLeft) {
			vec.x -= (FREEVIEW_SENS).toFloat()
		}

		if (pressedRight) {
			vec.x += (FREEVIEW_SENS).toFloat()
		}

		if (pressedUp) {
			vec.y += (FREEVIEW_SENS).toFloat()
		}

		if (pressedDown) {
			vec.y -= (FREEVIEW_SENS).toFloat()
		}

		return vec
	}

	fun tick(delta: Double) {
		pos + velocity * delta.toFloat()
	}

	companion object {
		const val FREEVIEW_SENS = 800.0
		const val MAX_ZOOM = 4f
		const val MIN_ZOOM = 0.1f
		const val ZOOM_STEP = 0.1f
	}
}
